import Guild from './Guild';
import BaseUser from './BaseUser';
import Client from './Client';
import GuildMember from './GuildMember';
import TextBasedChannel from './TextBasedChannel';
import { MessageContent } from '../util/Types';
export default class Message {
    client: Client;
    readonly id: string;
    content: string | null;
    webhookId: string | null;
    guild: Guild | null;
    author: BaseUser | null;
    member: GuildMember | null;
    channel: TextBasedChannel;
    flags: number;
    private baseAuthor;
    constructor(client: Client, data: any);
    private build;
    crosspost(): Promise<Message>;
    delete(): Promise<void>;
    reply(message: MessageContent): Promise<Message>;
    pin(reason?: string): Promise<Message>;
    unpin(reason?: string): Promise<Message>;
    startThread(name: string, options?: {
        autoArchiveDelay?: number;
        slowmode?: number;
        reason?: string;
    }): Promise<void>;
    supressEmbeds(): Promise<Message>;
    edit(message: MessageContent): Promise<Message>;
    modify(data: any): Promise<Message>;
    private parse;
    private waitForAuthor;
    private set;
    private static buildApiMessage;
}
