import BitsBlock from "./blocks/BitsBlock";
export default class Permissions extends BitsBlock {
    static FLAGS: {
        CREATE_INSTANT_INVITE: number;
        KICK_MEMBERS: number;
        BAN_MEMBERS: number;
        /**
         * ⚠️ **No bot truly needs the Administrator
         * permission** with the exception of some
         * moderation and anti-abuse type bots. You should
         * consider whether or not a group of less
         * priviliged permissions would suffice for your
         * use case. Requesting the Administrator
         * permission just puts your users at risk and can
         * lead to unneeded privacy concerns.
         */
        ADMINISTRATOR: number;
        MANAGE_CHANNELS: number;
        MANAGE_GUILD: number;
        ADD_REACTIONS: number;
        VIEW_AUDIT_LOG: number;
        PRIORITY_SPEAKER: number;
        STREAM: number;
        VIEW_CHANNEL: number;
        SEND_MESSAGES: number;
        SEND_TTS_MESSAGES: number;
        MANAGE_MESSAGES: number;
        EMBED_LINKS: number;
        ATTACH_FILES: number;
        READ_MESSAGE_HISTORY: number;
        MENTION_EVERYONE: number;
        USE_EXTERNAL_EMOJIS: number;
        VIEW_GUILD_INSIGHTS: number;
        CONNECT: number;
        SPEAK: number;
        MUTE_MEMBERS: number;
        DEAFEN_MEMBERS: number;
        MOVE_MEMBERS: number;
        USE_VAD: number;
        CHANGE_NICKNAME: number;
        MANAGE_NICKNAMES: number;
        MANAGE_ROLES: number;
        MANAGE_WEBHOOKS: number;
        MANAGE_EMOJIS_AND_STICKERS: number;
        USE_APPLICATION_COMMANDS: number;
        REQUEST_TO_SPEAK: number;
        MANAGE_EVENTS: number;
        MANAGE_THREADS: number;
        CREATE_PUBLIC_THREADS: number;
        CREATE_PRIVATE_THREADS: number;
        USE_EXTERNAL_STICKERS: number;
        SEND_MESSAGES_IN_THREADS: number;
        START_EMBEDDED_ACTIVITIES: number;
    };
    constructor(...flags: number[]);
    hasPermission(flag: number): boolean;
}
