"use strict";
/*
 * Copyright (c) 2021, knokbak and contributors.
 *
 * The Birb.JS Project: https://birb.js.org
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const MessageBlock_1 = __importDefault(require("./blocks/MessageBlock"));
const GuildChannel_1 = __importDefault(require("./GuildChannel"));
const Message_1 = __importDefault(require("./Message"));
const HTTPChannel_1 = __importDefault(require("./http/HTTPChannel"));
class TextBasedChannel extends GuildChannel_1.default {
    constructor(client, data, options, guild) {
        super(client, data, guild);
        this.messages = new MessageBlock_1.default(client, this.guild, options);
    }
    async send(message) {
        let data = Message_1.default['buildApiMessage'](this.client, message);
        let created = await HTTPChannel_1.default.createMessage(this.client, this.id, data);
        let msg = await (new Message_1.default(this.client, created))['waitForAuthor']();
        this.messages.cache.set(msg.id, msg);
        return msg;
    }
}
exports.default = TextBasedChannel;
