import { Guild } from '..';
import Client from './Client';
import TextBasedChannel from './TextBasedChannel';
export default class TextChannel extends TextBasedChannel {
    constructor(client: Client, data: any, options?: {
        maxSize?: number;
        maxAge?: number;
        checkInterval?: number;
        removeOldest?: boolean;
    }, guild?: Guild);
    private build;
    setName(name: string, reason?: string): Promise<TextChannel>;
    setPosition(position: number, reason?: string): Promise<TextChannel>;
    setTopic(topic: string, reason?: string): Promise<TextChannel>;
    setNSFW(nsfw: boolean, reason?: string): Promise<TextChannel>;
    setSlowmode(seconds: number, reason?: string): Promise<TextChannel>;
    setAutoArchive(minutes: number, reason?: string): Promise<TextChannel>;
    modify(data: any, reason?: string): Promise<TextChannel>;
    /**
     * Set the TextChannel's data to the cache.
     *
     * @returns {TextChannel} This TextChannel instance.
     * @protected
     */
    protected set(): TextChannel;
}
