"use strict";
/*
 * Copyright (c) 2021, knokbak and contributors.
 *
 * The Birb.JS Project: https://birb.js.org
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = require("..");
const TextBasedChannel_1 = __importDefault(require("./TextBasedChannel"));
class TextChannel extends TextBasedChannel_1.default {
    constructor(client, data, options, guild) {
        super(client, data, options, guild);
        this.build(data);
    }
    build(data) {
    }
    setName(name, reason) {
        return this.modify({ name }, reason);
    }
    setPosition(position, reason) {
        return this.modify({ position }, reason);
    }
    setTopic(topic, reason) {
        return this.modify({ topic }, reason);
    }
    setNSFW(nsfw, reason) {
        return this.modify({ nsfw }, reason);
    }
    setSlowmode(seconds, reason) {
        return this.modify({ rate_limit_per_user: seconds }, reason);
    }
    setAutoArchive(minutes, reason) {
        return this.modify({ default_auto_archive_duration: minutes }, reason);
    }
    async modify(data, reason) {
        let updated = await __1.HTTPChannel.modify(this.client, this.id, data, reason);
        this.build(updated);
        return this.set();
    }
    /**
     * Set the TextChannel's data to the cache.
     *
     * @returns {TextChannel} This TextChannel instance.
     * @protected
     */
    set() {
        this.guild.channels.cache.set(this.id, this);
        return this;
    }
}
exports.default = TextChannel;
