"use strict";
/*
 * Copyright (c) 2021, knokbak and contributors.
 *
 * The Birb.JS Project: https://birb.js.org
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const HTTPChannel_1 = __importDefault(require("./http/HTTPChannel"));
const TextBasedChannel_1 = __importDefault(require("./TextBasedChannel"));
class ThreadChannel extends TextBasedChannel_1.default {
    constructor(client, data, options) {
        super(client, data, options);
        this.build(data);
    }
    build(data) {
        console.log(data);
    }
    async modify(data, reason) {
        let updated = await HTTPChannel_1.default.modify(this.client, this.id, data, reason);
        this.build(updated);
        return this.set();
    }
    /**
     * Set the ThreadChannel's data to the cache.
     *
     * @returns {ThreadChannel} This ThreadChannel instance.
     * @protected
     */
    set() {
        this.guild.channels.cache.set(this.id, this);
        return this;
    }
}
exports.default = ThreadChannel;
