"use strict";
/*
 * Copyright (c) 2021, knokbak and contributors.
 *
 * The Birb.JS Project: https://birb.js.org
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Permissions_1 = __importDefault(require("../Permissions"));
class PermissionsBlock {
    constructor(client, ...flags) {
        this.client = null;
        this.bits = null;
        this.client = client;
        this.bits = new Permissions_1.default(...flags);
    }
    add(...flags) {
        this.bits.add(...flags);
        return this;
    }
    remove(...flags) {
        this.bits.remove(...flags);
        return this;
    }
    has(flag, options = {
        adminOverride: false
    }) {
        if (options.adminOverride) {
            return this.bits.hasPermission(flag);
        }
        else {
            return this.bits.has(flag);
        }
    }
    equals(check) {
        if (check instanceof PermissionsBlock) {
            return this.bits.flags == check.bits.flags;
        }
        else if (check instanceof Permissions_1.default) {
            return this.bits.flags == check.flags;
        }
        else if (typeof check == 'number') {
            return this.bits.flags == check;
        }
        else {
            throw new TypeError(`Expected PermissionsBlock, Permissions or number, got ${typeof check}`);
        }
    }
}
exports.default = PermissionsBlock;
