"use strict";
/*
 * Copyright (c) 2021, knokbak and contributors.
 *
 * The Birb.JS Project: https://birb.js.org
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Cache_1 = __importDefault(require("./Cache"));
class CGCache extends Cache_1.default {
    constructor(client, guild, options) {
        super(options);
        this.client = null;
        this.guild = null;
        this.client = client;
        this.guild = guild;
    }
    strip(data) {
        delete data.client;
        delete data.guild;
        return data;
    }
    rebuild(data) {
        data.client = this.client;
        data.guild = this.guild;
        return data;
    }
}
exports.default = CGCache;
