"use strict";
/*
 * Copyright (c) 2021, knokbak and contributors.
 *
 * The Birb.JS Project: https://birb.js.org
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const EmbedChild_1 = __importDefault(require("./EmbedChild"));
class EmbedAuthor extends EmbedChild_1.default {
    constructor(name, url, iconUrl) {
        super();
        this.name = null;
        this.url = null;
        this.iconUrl = null;
        this.name = name;
        this.url = url ?? null;
        this.iconUrl = iconUrl ?? null;
    }
    setName(name) {
        this.name = name;
    }
    setUrl(url) {
        this.url = url;
    }
    setIconUrl(iconUrl) {
        this.iconUrl = iconUrl;
    }
    removeUrl() {
        this.url = null;
    }
    removeIcon() {
        this.iconUrl = null;
    }
    /**
     * Format this class into an API-acceptable object.
     */
    format() {
        return {
            name: this.name,
            url: this.url,
            icon_url: this.iconUrl
        };
    }
}
exports.default = EmbedAuthor;
