"use strict";
/*
 * Copyright (c) 2021, knokbak and contributors.
 *
 * The Birb.JS Project: https://birb.js.org
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const EmbedChild_1 = __importDefault(require("./EmbedChild"));
class EmbedField extends EmbedChild_1.default {
    constructor(name, value, inline) {
        super();
        this.name = null;
        this.value = null;
        this.inline = false;
        this.name = name;
        this.value = value;
        this.inline = inline ?? false;
    }
    setName(name) {
        this.name = name;
    }
    setValue(value) {
        this.value = value;
    }
    setInline(inline) {
        this.inline = inline;
    }
    /**
     * Format this class into an API-acceptable object.
     */
    format() {
        return {
            name: this.name,
            value: this.value,
            inline: this.inline
        };
    }
}
exports.default = EmbedField;
