"use strict";
/*
 * Copyright (c) 2021, knokbak and contributors.
 *
 * The Birb.JS Project: https://birb.js.org
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const EmbedChild_1 = __importDefault(require("./EmbedChild"));
class EmbedFooter extends EmbedChild_1.default {
    constructor(text, iconUrl) {
        super();
        this.text = null;
        this.iconUrl = null;
        this.text = text;
        this.iconUrl = iconUrl ?? null;
    }
    setText(text) {
        this.text = text;
    }
    setIconUrl(iconUrl) {
        this.iconUrl = iconUrl;
    }
    removeIcon() {
        this.iconUrl = null;
    }
    /**
     * Format this class into an API-acceptable object.
     */
    format() {
        return {
            text: this.text,
            icon_url: this.iconUrl
        };
    }
}
exports.default = EmbedFooter;
