"use strict";
/*
 * Copyright (c) 2021, knokbak and contributors.
 *
 * The Birb.JS Project: https://birb.js.org
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const EmbedChild_1 = __importDefault(require("./EmbedChild"));
class EmbedMedia extends EmbedChild_1.default {
    constructor(url, height, width) {
        super();
        this.url = null;
        this.height = null;
        this.width = null;
        this.url = url;
        this.height = height ?? null;
        this.width = width ?? null;
    }
    setUrl(url) {
        this.url = url;
    }
    setHeight(height) {
        this.height = height;
    }
    setWidth(width) {
        this.width = width;
    }
    removeHeight() {
        this.height = null;
    }
    removeWidth() {
        this.width = null;
    }
    /**
     * Format this class into an API-acceptable object.
     */
    format() {
        return {
            url: this.url,
            height: this.height,
            width: this.width
        };
    }
}
exports.default = EmbedMedia;
