"use strict";
/*
 * Copyright (c) 2021, knokbak and contributors.
 *
 * The Birb.JS Project: https://birb.js.org
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActivityType = exports.GatewayCloseCode = exports.PacketOperation = exports.Status = exports.VerificationLevel = exports.NotificationLevel = exports.ExplicitContentFilterLevel = exports.MFALevel = exports.NSFWLevel = exports.Addons = exports.Color = exports.WebsocketWarning = exports.WebsocketProcessingError = exports.WebsocketError = exports.ShardingError = exports.MemoryLeakWarning = exports.GuildError = exports.ClientWarning = exports.ClientError = exports.CacheError = exports.BirbJSError = exports.Role = exports.Pair = exports.Intents = exports.Guild = exports.Client = exports.Cache = exports.Websocket = exports.EmbedMedia = exports.EmbedFooter = exports.EmbedField = exports.EmbedChild = exports.EmbedAuthor = exports.Embed = exports.BaseComponent = exports.Request = exports.HTTPUser = exports.HTTPChannel = exports.HTTPGuild = exports.Permissions = exports.UserBlock = exports.RoleBlock = exports.MessageBlock = exports.GuildMemberRoleBlock = exports.GuildMemberBlock = exports.GuildBlock = exports.ChannelBlock = exports.CachedBlock = exports.BitsBlock = exports.Snowflake = void 0;
exports._test = void 0;
/*
 * WHEN EDITING THIS, THERE ARE SOME RULES WE NEED TO READ,
 * FOLLOW, AND BE AWARE OF:
 *
 *  - If importing a class, type, enum or other property,
 *    you must add it in alphabetical order. It must also
 *    be sorted based on the file structure. Usually, your
 *    IDE should show this for you.
 *  - When exporting, you should add the properties in the
 *    order they're imported.
 *  - Do not modify this comment.
 */
const snowflake_1 = require("@sapphire/snowflake");
Object.defineProperty(exports, "Snowflake", { enumerable: true, get: function () { return snowflake_1.Snowflake; } });
const BitsBlock_1 = __importDefault(require("./classes/blocks/BitsBlock"));
exports.BitsBlock = BitsBlock_1.default;
const CachedBlock_1 = __importDefault(require("./classes/blocks/CachedBlock"));
exports.CachedBlock = CachedBlock_1.default;
const ChannelBlock_1 = __importDefault(require("./classes/blocks/ChannelBlock"));
exports.ChannelBlock = ChannelBlock_1.default;
const GuildBlock_1 = __importDefault(require("./classes/blocks/GuildBlock"));
exports.GuildBlock = GuildBlock_1.default;
const GuildMemberBlock_1 = __importDefault(require("./classes/blocks/GuildMemberBlock"));
exports.GuildMemberBlock = GuildMemberBlock_1.default;
const GuildMemberRoleBlock_1 = __importDefault(require("./classes/blocks/GuildMemberRoleBlock"));
exports.GuildMemberRoleBlock = GuildMemberRoleBlock_1.default;
const MessageBlock_1 = __importDefault(require("./classes/blocks/MessageBlock"));
exports.MessageBlock = MessageBlock_1.default;
const RoleBlock_1 = __importDefault(require("./classes/blocks/RoleBlock"));
exports.RoleBlock = RoleBlock_1.default;
const UserBlock_1 = __importDefault(require("./classes/blocks/UserBlock"));
exports.UserBlock = UserBlock_1.default;
const Permissions_1 = __importDefault(require("./classes/Permissions"));
exports.Permissions = Permissions_1.default;
const HTTPGuild_1 = __importDefault(require("./classes/http/HTTPGuild"));
exports.HTTPGuild = HTTPGuild_1.default;
const HTTPChannel_1 = __importDefault(require("./classes/http/HTTPChannel"));
exports.HTTPChannel = HTTPChannel_1.default;
const HTTPUser_1 = __importDefault(require("./classes/http/HTTPUser"));
exports.HTTPUser = HTTPUser_1.default;
const Request_1 = __importDefault(require("./classes/http/Request"));
exports.Request = Request_1.default;
const BaseComponent_1 = __importDefault(require("./classes/message/BaseComponent"));
exports.BaseComponent = BaseComponent_1.default;
const Embed_1 = __importDefault(require("./classes/message/embed/Embed"));
exports.Embed = Embed_1.default;
const EmbedAuthor_1 = __importDefault(require("./classes/message/embed/EmbedAuthor"));
exports.EmbedAuthor = EmbedAuthor_1.default;
const EmbedChild_1 = __importDefault(require("./classes/message/embed/EmbedChild"));
exports.EmbedChild = EmbedChild_1.default;
const EmbedField_1 = __importDefault(require("./classes/message/embed/EmbedField"));
exports.EmbedField = EmbedField_1.default;
const EmbedFooter_1 = __importDefault(require("./classes/message/embed/EmbedFooter"));
exports.EmbedFooter = EmbedFooter_1.default;
const EmbedMedia_1 = __importDefault(require("./classes/message/embed/EmbedMedia"));
exports.EmbedMedia = EmbedMedia_1.default;
const Websocket_1 = __importDefault(require("./classes/websocket/Websocket"));
exports.Websocket = Websocket_1.default;
const Cache_1 = __importDefault(require("./classes/cache/Cache"));
exports.Cache = Cache_1.default;
const Client_1 = __importDefault(require("./classes/Client"));
exports.Client = Client_1.default;
const Guild_1 = __importDefault(require("./classes/Guild"));
exports.Guild = Guild_1.default;
const Intents_1 = __importDefault(require("./classes/Intents"));
exports.Intents = Intents_1.default;
const Pair_1 = __importDefault(require("./util/Pair"));
exports.Pair = Pair_1.default;
const Role_1 = __importDefault(require("./classes/Role"));
exports.Role = Role_1.default;
const BirbJSError_1 = __importDefault(require("./errors/BirbJSError"));
exports.BirbJSError = BirbJSError_1.default;
const CacheError_1 = __importDefault(require("./errors/CacheError"));
exports.CacheError = CacheError_1.default;
const ClientError_1 = __importDefault(require("./errors/ClientError"));
exports.ClientError = ClientError_1.default;
const ClientWarning_1 = __importDefault(require("./errors/ClientWarning"));
exports.ClientWarning = ClientWarning_1.default;
const GuildError_1 = __importDefault(require("./errors/GuildError"));
exports.GuildError = GuildError_1.default;
const MemoryLeakWarning_1 = __importDefault(require("./errors/MemoryLeakWarning"));
exports.MemoryLeakWarning = MemoryLeakWarning_1.default;
const ShardingError_1 = __importDefault(require("./errors/ShardingError"));
exports.ShardingError = ShardingError_1.default;
const WebsocketError_1 = __importDefault(require("./errors/WebsocketError"));
exports.WebsocketError = WebsocketError_1.default;
const WebsocketProcessingError_1 = __importDefault(require("./errors/WebsocketProcessingError"));
exports.WebsocketProcessingError = WebsocketProcessingError_1.default;
const WebsocketWarning_1 = __importDefault(require("./errors/WebsocketWarning"));
exports.WebsocketWarning = WebsocketWarning_1.default;
const Color_1 = __importDefault(require("./util/Color"));
exports.Color = Color_1.default;
const Addons_1 = __importDefault(require("./util/Addons"));
exports.Addons = Addons_1.default;
const Constants_1 = require("./util/Constants");
Object.defineProperty(exports, "NSFWLevel", { enumerable: true, get: function () { return Constants_1.NSFWLevel; } });
Object.defineProperty(exports, "MFALevel", { enumerable: true, get: function () { return Constants_1.MFALevel; } });
Object.defineProperty(exports, "ExplicitContentFilterLevel", { enumerable: true, get: function () { return Constants_1.ExplicitContentFilterLevel; } });
Object.defineProperty(exports, "NotificationLevel", { enumerable: true, get: function () { return Constants_1.NotificationLevel; } });
Object.defineProperty(exports, "VerificationLevel", { enumerable: true, get: function () { return Constants_1.VerificationLevel; } });
Object.defineProperty(exports, "Status", { enumerable: true, get: function () { return Constants_1.Status; } });
Object.defineProperty(exports, "PacketOperation", { enumerable: true, get: function () { return Constants_1.PacketOperation; } });
Object.defineProperty(exports, "GatewayCloseCode", { enumerable: true, get: function () { return Constants_1.GatewayCloseCode; } });
Object.defineProperty(exports, "ActivityType", { enumerable: true, get: function () { return Constants_1.ActivityType; } });
function _test() {
    console.info('test passed; index.ts is valid');
}
exports._test = _test;
