import BaseUser from '../classes/BaseUser';
import Channel from '../classes/Channel';
import ClientUser from '../classes/ClientUser';
import Guild from '../classes/Guild';
import Embed from '../classes/message/embed/Embed';
import Role from '../classes/Role';
import User from '../classes/User';
export declare type GuildResolvable = Guild | string;
export declare type RoleResolvable = Role | string;
export declare type ChannelResolvable = Channel | string;
export declare type UserResolvable = User | ClientUser | BaseUser | string;
export declare type EventResolvable = 'ready' | 'waitingForGuilds' | 'guildAvailable' | 'guildCreate' | 'guildUpdate' | 'message';
export declare type ActivityStatus = 'online' | 'idle' | 'dnd' | 'invisible';
export declare type MessageContent = string | Embed | {
    content?: string;
    embeds?: [Embed];
    tts?: boolean;
    nonce?: string;
    mentionRepliedUser?: boolean;
    allowedMentions?: {
        parse?: ['users' | 'roles' | 'everyone'];
        users?: [UserResolvable];
        roles?: [RoleResolvable];
    };
};
